% Computes CD test statistics (Pesaran, 2015). The CD stats are calculated on the OLS
% and IV residuals from the panel IV/OLS table in the paper; these residuals were 
% computed in STATA and then exported for these tests.

clear
LASTN=maxNumCompThreads(12)
addpath('matlabprograms')
addpath('../mydata')

load('../mydata/results_saa2a4BOTH2_iFE1ch.mat')


ResOLS_saa2a4FEi=xlsread('ResOLS_saa2a4FEi_panel_insampleBOTH2_1ch.xls')';

CSDstatResOLS_saa2a4FEi=CSDtestPesaran15(ResOLS_saa2a4FEi);


save('../mydata/results_saa2a4BOTH2_iFE1ch.mat')

