function [LM,epsilon,J]=SuChen15(y,x,num,T,N,thres,initial_b,r1,F,L)

result1=1;


%%
p=size(x,2);

epsilon=y-reshape(F*L,N*T,1)-x*r1;

e=reshape(epsilon,T,N);
LM=zeros(p,1);
xx=reshape(x,T,[]);

for k=1:p
for i=1:N
    xk=xx(:,N*(k-1)+i);
    LM(k)=LM(k)+e(:,i)'*xk*((xk'*xk)\xk')*e(:,i);
end
end

H=zeros(T*N,T,p);
for k=1:p
    for i=1:N
        xk=xx(:,N*(k-1)+i);
        H((i-1)*T+1:i*T,:,k)=(eye(T)-F*((F'*F)\F'))*xk*((xk'*xk)\xk')*(eye(T)-F*((F'*F)\F'));
    end
end

B=zeros(p,1);
for k=1:p
    for i=1:N
        for t=1:T
            B(k)=B(k)+e(t,i).^2*H(t+T*(i-1),t,k)/sqrt(N);
        end
    end
end

b=zeros(N,T,p);
for i=1:N
    for t=1:T
        for k=1:p
                xk=xx(:,N*(k-1)+i);
                omega=(xk'*xk./T)^(-1/2);
                for s=1:T
                    b(i,t,k)=b(i,t,k)+F(t,:)*F(s,:)'*xk(s)/T;
                end
                b(i,t,k)=omega*(xk(t)-b(i,t,k));
        end
    end
end


V=zeros(p,1);
for k=1:p
    for i=1:N
        for t=2:T
            summ=0;
            for s=1:t-1
                summ=summ+e(s,i)*b(i,s,k);
            end
            V(k)=V(k)+4*(e(t,i)*b(i,t,k)*summ).^2/N/T/T;
        end
    end
end


J=zeros(p,1);
for k=1:p
    J(k)=(LM(k)/sqrt(N)-B(k))/sqrt(V(k));
end


        

